#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <string.h>
#include "Integrated.h"
#include "Pish.h"

//checks if there is a special symbol for redirection
int redirectCheck(char* command)
{
    int check;
    if(strchr(command, '|') != NULL){
        check = 1;
    }
    else if (strpbrk(command, ">>") != NULL){
        check = 2;
    }
    else if (strchr(command, '>') != NULL){
        check = 3;
    }
    else if (strchr(command, '<') != NULL){
        check = 4;
    }
    else{
        check = 0; 
}
//i/o Redirection (void my need to be changed)
void ioRedirect(int sym, char* command)
{
  // |1, >>2, >3, <4
  if(sym == 1)
  {
    // |
  }
  else if(sym == 2)
  {
    // >> Append
    // does not replace file contents just adds
  }
  else if(sym == 3)
  {
    // > Redirecting output
    // create a file if doesnt exist
    // replaces files contents
  }
  else
  {
    // < ??
  }
}
         
// Prints a prompt and then reads a command from the terminal
char* getInput(void)
{
    char prompt = '$';
    char *commandLine;

    printf("%c ", prompt);
    scanf("%[^\n]", commandLine);

    return commandLine;
}

// Executes a command to the system
void exec(char* command)
{
    system(command);
}

// Main function for Pish program
void Pish(void)
{
    char* command;
    int retval;
    int redirect;
    
    while (1)
    {
        command = getInput();
	//Parse command
	// Need to check for |,<,>,>>
	//redirect = redirectCheck(command);
	if (redirect > 0)
        {
          //ioRedirect(redirect, command);
	}
	else
	{
	  char* token = strtok(command, " ");
	  while(token != NULL)
          {
	    //This only holds 1 command at a time then it overrides
	    //Will need modified
	    token = strtok(NULL, " ");
	  }
	{
	  
	IntegratedCheck(command);
        retval = fork();
        // Child
        if (retval == 0)
        {
            // This is the child process
            // Setup the child's process environment here
            // E.g., where is standard I/O, how to handle signals?
            exec(command);
            // exec does not return if it succeeds
            printf("ERROR: Could not execute %s\n", command);
            exit(1);
        }
        // Parent
        else
        {
            // This is the parent process; Wait for the child to finish
            int pid = retval;
            wait(pid);
        }
        // TODO: Remove break when while loop doesn't break program
        break;
    }
}
